<template>
  <q-dialog
    ref="dialog"
    @hide="$emit('hide')"
  >
    <q-card
      class="q-dialog-plugin"
      :style="{ minWidth: '800px' }"
    >
      <q-card-section>
        <div
          class="text-h5 text-weight-bolder text-grey-9 q-pb-sm"
          v-text="'Avaliação'"
        />
      </q-card-section>

      <q-card-section>
        <q-form class="q-gutter-y-md">
          <q-card
            v-for="key in Object.keys(form)"
            :key="key"
            bordered
            flat
          >
            <q-card-section class="q-px-sm q-pt-sm q-pb-xs">
              <div
                class="text-grey-7 q-px-xs"
                v-text="label[key]"
              />
            </q-card-section>

            <q-card-section class="row q-pa-sm">
              <q-input
                v-model="form[key].value"
                :class="{ 'q-pb-lg': $v.form[key].value.$error }"
                class="col q-pa-xs"
                color="primary"
                fill-mask="0"
                mask="###.##"
                label="Nota"
                bottom-slots
                outlined
                dense
                :error="$v.form[key].value.$error"
              >
                <template v-slot:error>
                  <div
                    v-for="(message, index) in errorMessages($v.form[key].value)"
                    :key="index"
                    v-text="message"
                  />
                </template>
              </q-input>

              <q-input
                v-model="form[key].comment"
                :class="{ 'q-pb-lg': $v.form[key].value.$error }"
                class="col q-pa-xs"
                label="Comentário"
                color="primary"
                bottom-slots
                autogrow
                outlined
                dense
              />
            </q-card-section>
          </q-card>
        </q-form>
      </q-card-section>

      <q-card-actions align="right">
        <q-btn
          class="q-mr-sm q-mb-sm"
          color="primary"
          label="OK"
          @click="save"
        />
      </q-card-actions>
    </q-card>
  </q-dialog>
</template>

<script>
import { ErrorMessagesMixin } from '../../mixin/error-messages'
import { required, maxValue } from 'vuelidate/lib/validators'

export default {
  name: 'FormRating',
  mixins: [ErrorMessagesMixin],
  props: {
    error: {
      type: Boolean,
      required: true
    },
    info: {
      type: Object,
      default: () => ({})
    }
  },
  data () {
    return {
      form: {
        competence1: {
          comment: null,
          value: ''
        },
        competence2: {
          comment: null,
          value: ''
        },
        competence3: {
          comment: null,
          value: ''
        },
        competence4: {
          comment: null,
          value: ''
        },
        competence5: {
          comment: null,
          value: ''
        }
      },
      label: {
        competence1: 'Competência I',
        competence2: 'Competência II',
        competence3: 'Competência III',
        competence4: 'Competência IV',
        competence5: 'Competência V'
      }
    }
  },
  validations: {
    form: {
      competence1: {
        value: {
          required,
          maxValue: maxValue(200)
        }
      },
      competence2: {
        value: {
          required,
          maxValue: maxValue(200)
        }
      },
      competence3: {
        value: {
          required,
          maxValue: maxValue(200)
        }
      },
      competence4: {
        value: {
          required,
          maxValue: maxValue(200)
        }
      },
      competence5: {
        value: {
          required,
          maxValue: maxValue(200)
        }
      }
    }
  },
  mounted () {
    if (this.error) {
      this.$v.form.$touch()
    } else {
      this.$v.form.$reset()
    }

    if (this.info && Object.keys(this.info).length) {
      this.form = this.info
    }
  },
  methods: {
    show () {
      this.$refs.dialog.show()
    },
    hide () {
      this.$refs.dialog.hide()
    },
    save () {
      this.$v.form.$touch()

      if (this.$v.form.$error) {
        return undefined
      }

      this.$emit('ok', this.form)
      this.hide()
    }
  }
}
</script>
